#!/bin/bash

set -xe

clang -DSTATIC_SOURCE -g -Weverything -O0 -o xhartae xhartae.c -lxcb -lxcb-image

gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_0.o chapter/chapter_0.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_1.o chapter/chapter_1.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_2.o chapter/chapter_2.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_3.o chapter/chapter_3.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_4.o chapter/chapter_4.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_5.o chapter/chapter_5.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_6.o chapter/chapter_6.c

gcc -g -Wall -Wextra -Wpedantic -O0 -c -o xhartae.o xhartae.c

gcc -o xhartae xhartae.o chapter/chapter_0.o chapter/chapter_1.o chapter/chapter_2.o chapter/chapter_3.o chapter/chapter_4.o chapter/chapter_5.o chapter/chapter_6.o  -lxcb -lxcb-image

gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o program/program_0 program/program_0.c
gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o program/program_1 program/program_1.c
gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o program/program_2 program/program_2.c
gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o program/program_4 program/program_4.c
gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o program/program_z program/program_z.c

gcc -g -Wall -Wextra -Wpedantic -Werror -Ofast -o example/xcb_window example/xcb_window.c -lxcb

#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_0.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_0.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_1.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_1.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_2.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_2.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_3.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_3.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_4.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_4.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_5.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_5.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_6.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_6.c
#~splint -weak -warnposix -retvalother -syntax -type xhartae.c

#~valgrind --show-leak-kinds=all --leak-check=full --log-file=log.txt ./xhartae

#~xighlight -V < log.txt

exit
